myPredict = function (object, newdata = NULL, se.fit = FALSE, re.form, allow.new.levels = FALSE, 
    type = c("link", "response", "conditional", "zprob", "zlink"), 
    zitype = NULL, na.action = na.pass, debug = FALSE, ...) 
{
        print("001")
    if (!is.null(zitype)) {
        warning("zitype is deprecated: please use type instead")
        type <- zitype
    }
    type <- match.arg(type)
    if (!missing(re.form)) 
        stop("re.form not yet implemented")
        print("002")
    
    mc <- mf <- object$call
mf$weights=newdata$`(weights)` # FIRST DIFFERENT LINE: get weights from newdata rather than original data
    m <- match(c("subset", "weights", "offset", "na.action"), 
        names(mf), 0L)
    mf <- mf[c(1L, m)]
    mf$drop.unused.levels <- TRUE
    mf[[1]] <- as.name("model.frame")
    mf$formula <- RHSForm(object$modelInfo$allForm$combForm, 
        as.form = TRUE)
        print("003")
    if (is.null(newdata)) {
        mf$data <- mc$data
        newFr <- object$fr
    }
    else {
        mf$data <- newdata
        mf$na.action <- na.action
        newFr <- eval.parent(mf)
    }
    omi <- object$modelInfo
    respCol <- match(respNm <- names(omi$respCol), names(newFr))
    newFr[[respNm]] <- NA
    augFr <- rbind(object$fr, newFr)
        print("004")
    
    w <- nrow(object$fr) + seq_len(nrow(newFr))
    yobs <- augFr[[names(omi$respCol)]]
    ziPredNm <- switch(type, response = "corrected", link = , 
        conditional = "uncorrected", zlink = , zprob = "prob", 
        stop("unknown type ", type))
    
    ziPredCode <- .valid_zipredictcode[ziPredNm]
    print("005")
    TMBStruc <- eval.parent(mkTMBStruc(RHSForm(omi$allForm$formula, 
        as.form = TRUE), omi$allForm$ziformula, omi$allForm$dispformula, 
        omi$allForm$combForm, mf, fr = augFr, yobs = yobs, respCol = respCol, 
        weights = model.weights(augFr), contrasts=NULL, family = omi$family, # SECOND DIFFERENT LINE: added contrasts arg.
        ziPredictCode = ziPredNm, doPredict = as.integer(se.fit), 
        whichPredict = w, REML = omi$REML))
    print("006")
    
    if (debug) 
        return(TMBStruc)
    assertIdenticalModels(TMBStruc$data.tmb, object$obj$env$data, 
        allow.new.levels)
    newObj <- with(TMBStruc, MakeADFun(data.tmb, parameters, 
        map = mapArg, random = randomArg, profile = NULL, silent = TRUE, 
        DLL = "glmmTMB"))
    
    oldPar <- object$fit$par
    newObj$fn(oldPar)
    lp <- newObj$env$last.par
    na.act <- attr(model.frame(object), "na.action")
    do.napred <- missing(newdata) && !is.null(na.act)
    if (!se.fit) {
        pred <- newObj$report(lp)$mu_predict
    }
    else {
        H <- with(object, optimHess(oldPar, obj$fn, obj$gr))
        sdr <- sdreport(newObj, oldPar, hessian.fixed = H, getReportCovariance = FALSE)
        sdrsum <- summary(sdr, "report")
        pred <- sdrsum[, "Estimate"]
        se <- sdrsum[, "Std. Error"]
    }
    if (do.napred) {
        pred <- napredict(na.act, pred)
        if (se.fit) 
            se <- napredict(na.act, se)
    }
    if (type %in% c("zlink", "link")) {
        ff <- object$modelInfo$family
        if (!(type == "link" && ff$link == "identity")) {
            if (type == "zlink") {
                ff <- make.link("logit")
            }
            pred <- ff$linkfun(pred)
            if (se.fit) 
                se <- se/ff$mu.eta(pred)
        }
    }
    if (!se.fit) 
        return(pred)
    else return(list(fit = pred, se.fit = se))
}
environment(myPredict)<-asNamespace('glmmTMB') # so we look for functions like "RHSForm" w/in glmmTMB (i.e. glmmTMB:::RHSForm)

